#!/usr/bin/env perl
#-*- Mode: perl; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-

# Functions for www.guiaroji.com.mx search filtering.
#
# Copyright (C) 2000-2001 The Free Software Foundation
#
# Authors: Arturo Espinosa <arturo@ximian.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.

sub quote
{
  my $str = $_[0];
  my $ent;
  my %entities = ('<', "&lt;",
			   '>', "&gt;",
			   '\'', "&apos;",
			   '"', "&quot;",
			   '&', "&amp;",
			   '', "&aacute;",
			   '', "&eacute;",
			   '', "&iacute;",
			   '', "&oacute;",
			   '', "&uacute;",
			   '', "&ntilde;",
			   ' ', "%20");

  foreach $ent (keys %entities)
  {
    $str =~ s/$ent/$entities{$ent}/g;
  }
  
  return $str;
}

sub unquote
{
  my $str = $_[0];
  my $ent;
  my %entities = ("&lt;", '<',
			   "&gt;", '>',
			   "&apos;", '\'',
			   "&quot;", '"',
			   "&amp;", '&',
			   "&aacute;", '',
			   "&eacute;", '',
			   "&iacute;", '',
			   "&oacute;", '',
			   "&uacute;", '',
			   "&ntilde;", '');

  foreach $ent (keys %entities)
  {
    $str =~ s/$ent/$entities{$ent}/g;
  }
  
  return $str;
}

sub capfirst
{
  my $str = $_[0];

  $str =~ s/,/, /g;
  
  while ($str =~ s/ ([a-z])/__\1/)
  {
    $up = uc ($1);
    $str =~ s/__./_$up/;
  }

  $str =~ s/_/ /g;
  $str =~ s/, /,/g;
  return $str;
}

sub filter
{
  my $fd = $_[0];
  my ($start, $res);

  while (<$fd>)
  {
    $start = 1 if /^ *<tr><th/i;
    next if !$start;
    next if !/^ *<td><font/i;
    last if /^ *<\/table>/i;

    chomp;
    s/^ +//;
    s/<td><font face=\"arial\"><a href=\"gr[a-z]+.pl\?archivo=//i;
    s/\.gif[^>]*>/,/i;
    s/<\/a><\/td>/,/i;
    s/  / /g;
    
    $res .= $_;
  }

  $res =~ s/,$//;
  $res = &capfirst (lc (&unquote ($res)));

  return $res;
}

1;
